#property copyright "Copyright  2010, sangmane@forexfactory.com."
#property link      "mailto:steven00@fastmail.fm"
#property description "Alert setup by CJA 2014"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
//---- indicator parameters
input string note1 = "zzzzzzzzzzzzzz  indicator parameters  zzzzzzzzzzzzzzzz";//zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
extern int ExtDepth=7;//Depth
extern int ExtDeviation=5;//Deviation
extern int ExtBackstep=3;//BackStep
extern color CurrentLabelColor = clrWhite;
extern color HistoricalLabelColor = clrDarkKhaki; 
extern color SignalLabelColor     = clrAqua; 

input string note2 = "zzzzzzzzzzzzzzzzzzz  Alert inputs  zzzzzzzzzzzzzzzzzzzz";//zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
input double AlertValue = 3;//Alert value
input bool AlertON = true;//Message Box Alert
input bool SoundON = true;//Sound Alert
input int  SoundNumber = 2;//Number of times Sound repeats
input string AlertSoundFile = "news.wav";//Sound File

//OSMa_c
extern int FastEMAPeriod=8;
extern int SlowEMAPeriod=20;
extern int SignalSMAPeriod=9;


double ZigzagBuffer[];
double HighMapBuffer[];
double LowMapBuffer[];
int level=3; // recounting's depth 
bool downloadhistory=false;
double Pip;
bool Started=False;

int alerts1=0;
int alerts2=0;
int timeframe;
string TF;

int digits; 
double  Poin;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   if (Point==0.00001) digits=100000;
   else {
      if (Point==0.001) digits=1000;
//       else Poin=Point;
   }
  IndicatorBuffers(3);
//---- drawing settings
   SetIndexStyle(0,DRAW_SECTION);
//---- indicator buffers mapping
   SetIndexBuffer(0,ZigzagBuffer);
   SetIndexBuffer(1,HighMapBuffer);
   SetIndexBuffer(2,LowMapBuffer);
   SetIndexEmptyValue(0,0.0);

//---- indicator short name
   IndicatorShortName("ZigZag("+ExtDepth+","+ExtDeviation+","+ExtBackstep+")");
   if(Digits==3 || Digits==5) Pip = 10*Point;
   else Pip = Point; 
   
      	switch(timeframe)
	{
		case 1:		TF="M1";  break;
		case 5:		TF="M5";  break;
		case 15:		TF="M15"; break;
		case 30:		TF="M30"; break;
		case 60:		TF="H1";  break;
		case 240:	TF="H4";  break;
		case 1440:	TF="D1";  break;
		case 10080:	TF="W1";  break;
		case 43200:	TF="MN1"; break;
		default:	  {timeframe = Period(); init(); return(0);}
	}  
	
	//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
    DelObj();
 
    return(0);
  }

void DelObj()
  {
   string ObjName;
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
     ObjName = ObjectName(i);
     if(StringFind(ObjName,"ZZLabel",0)>=0)
       ObjectDelete(ObjName);
   }
   return;
  }
//+------------------------------------------------------------------+
//                                                                   +
//+------------------------------------------------------------------+  
int start()
  {
   int i, counted_bars = IndicatorCounted();
   int limit,counterZ,whatlookfor;
   int shift,back,lasthighpos,lastlowpos;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow;
   double OSMa_c;
   
   if (counted_bars==0 && downloadhistory) // history was downloaded
     {
      ArrayInitialize(ZigzagBuffer,0.0);
      ArrayInitialize(HighMapBuffer,0.0);
      ArrayInitialize(LowMapBuffer,0.0);
     }
   if (counted_bars==0) 
     {
      limit=Bars-ExtDepth;
      downloadhistory=true;
     }
   if (counted_bars>0) 
     {
      while (counterZ<level && i<100)
        {
         res=ZigzagBuffer[i];
         if (res!=0) counterZ++;
         i++;
        }
      i--;
      limit=i;
      if (LowMapBuffer[i]!=0) 
        {
         curlow=LowMapBuffer[i];
         whatlookfor=1;
        }
      else
        {
         curhigh=HighMapBuffer[i];
         whatlookfor=-1;
        }
      for (i=limit-1;i>=0;i--)  
        {
         ZigzagBuffer[i]=0.0;  
         LowMapBuffer[i]=0.0;
         HighMapBuffer[i]=0.0;
        }
     }
      
   for(shift=limit; shift>=0; shift--)
     {
      val=Low[iLowest(NULL,0,MODE_LOW,ExtDepth,shift)];
      if(val==lastlow) val=0.0;
      else 
        { 
         lastlow=val; 
         if((Low[shift]-val)>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=LowMapBuffer[shift+back];
               if((res!=0)&&(res>val)) LowMapBuffer[shift+back]=0.0; 
              }
           }
        } 
      if (Low[shift]==val) LowMapBuffer[shift]=val; else LowMapBuffer[shift]=0.0;
      //--- high
      val=High[iHighest(NULL,0,MODE_HIGH,ExtDepth,shift)];
      if(val==lasthigh) val=0.0;
      else 
        {
         lasthigh=val;
         if((val-High[shift])>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=HighMapBuffer[shift+back];
               if((res!=0)&&(res<val)) HighMapBuffer[shift+back]=0.0; 
              } 
           }
        }
      if (High[shift]==val) HighMapBuffer[shift]=val; else HighMapBuffer[shift]=0.0;
     }

   // final cutting 
   if (whatlookfor==0)
     {
      lastlow=0;
      lasthigh=0;  
     }
   else
     {
      lastlow=curlow;
      lasthigh=curhigh;
     }
   for (shift=limit;shift>=0;shift--)
     {
      res=0.0;
      bool OutOfForLoop=False;
      switch(whatlookfor)
        {
         case 0: // look for peak or lawn 
            if (lastlow==0 && lasthigh==0)
              {
               if (HighMapBuffer[shift]!=0)
                 {
                  lasthigh=High[shift];
                  lasthighpos=shift;
                  whatlookfor=-1;
                  ZigzagBuffer[shift]=lasthigh;
                  res=1;
                 }
               if (LowMapBuffer[shift]!=0)
                 {
                  lastlow=Low[shift];
                  lastlowpos=shift;
                  whatlookfor=1;
                  ZigzagBuffer[shift]=lastlow;
                  res=1;
                 }
              }
             break;  
         case 1: // look for peak
            if (LowMapBuffer[shift]!=0.0 && LowMapBuffer[shift]<lastlow && HighMapBuffer[shift]==0.0)
              {
               ZigzagBuffer[lastlowpos]=0.0;
               lastlowpos=shift;
               lastlow=LowMapBuffer[shift];
               ZigzagBuffer[shift]=lastlow;
               res=1;
              }
            if (HighMapBuffer[shift]!=0.0 && LowMapBuffer[shift]==0.0)
              {
               lasthigh=HighMapBuffer[shift];
               lasthighpos=shift;
               ZigzagBuffer[shift]=lasthigh;
               whatlookfor=-1;
               res=1;
              }   
            break;               
         case -1: // look for lawn
            if (HighMapBuffer[shift]!=0.0 && HighMapBuffer[shift]>lasthigh && LowMapBuffer[shift]==0.0)
              {
               ZigzagBuffer[lasthighpos]=0.0;
               lasthighpos=shift;
               lasthigh=HighMapBuffer[shift];
               ZigzagBuffer[shift]=lasthigh;
              }
            if (LowMapBuffer[shift]!=0.0 && HighMapBuffer[shift]==0.0)
              {
               lastlow=LowMapBuffer[shift];
               lastlowpos=shift;
               ZigzagBuffer[shift]=lastlow;
               whatlookfor=1;
              }   
            break;               
         default: OutOfForLoop=True; 
        }
        if(OutOfForLoop) break;
     }
     //////////////////
     if(counted_bars<1)
     {
       DelObj();     
       limit = Bars-1;
     }
     else limit = 0;
     for(i = limit; i>=0; i--)
     {
     int k = i;
     double zz;
     double d1=0,d2=0,d3=0;
     datetime t1=0,t2=0,t3=0;
     while(k<Bars-2)
     {
       zz = ZigzagBuffer[k];
       if(zz!=0)
       {         
         d1 = d2; d2 = d3; d3 = zz;
         t1 = t2; t2 = t3; t3 = Time[k];
       }
       if(d1>0) break;
       k++;  
     }
     if(d1==0) continue;
     double LabelPos;
     int ib = iBarShift(NULL,0,t1);
    int ib2 = iBarShift(NULL,0,t2);
       OSMa_c  = NormalizeDouble(iOsMA(NULL,0,8,20,9,PRICE_CLOSE,ib2),digits);
     if(d1>d2) LabelPos = NormalizeDouble(High[ib]+0.7*iATR(NULL,0,10,ib),Digits);
     else LabelPos = Low[ib];
     
     
     string ObjName = "ZZLabel_Leg1";
     if(ObjectFind(ObjName)<0)
       ObjectCreate(ObjName,OBJ_TEXT,0,t1,LabelPos);
     else
       ObjectMove(ObjName,0,t1,LabelPos);
       OSMa_c  = iOsMA(NULL,0,8,20,9,PRICE_CLOSE,ib)*digits;
     ObjectSetText(ObjName,DoubleToStr(MathAbs(d2-d1)/Pip,1)+"/"+DoubleToString(OSMa_c,0),7,"Verdana",SignalLabelColor);       
     //////////////////////
     if(i==0)
     {
     LabelPos = Close[0];
     ObjName = "ZZLabel_Bid";
     int rOffset = 5*Period()*60;
     if(ObjectFind(ObjName)<0)
       ObjectCreate(ObjName,OBJ_TEXT,0,Time[0]+rOffset,LabelPos);
     else
       ObjectMove(ObjName,0,Time[0]+rOffset,LabelPos);                  
          OSMa_c  = iOsMA(NULL,0,8,20,9,PRICE_CLOSE,0)*digits;
  ObjectSetText(ObjName,DoubleToStr(MathAbs(Close[0]-d1)/Pip,1)+"/"+DoubleToString(OSMa_c,0),7,"Verdana",CurrentLabelColor);     
     }
     //////////////////////     
     ib = iBarShift(NULL,0,t2);
     if(d2>d3) LabelPos = NormalizeDouble(High[ib]+0.7*iATR(NULL,0,10,ib),Digits);
     else LabelPos = Low[ib];
     ObjName = "ZZLabel"+t1;
     if(ObjectFind(ObjName)<0)
     {
     ObjectCreate(ObjName,OBJ_TEXT,0,t2,LabelPos);
     OSMa_c  = iOsMA(NULL,0,8,20,9,PRICE_CLOSE,ib2)*digits;
     ObjectSetText(ObjName,DoubleToStr(MathAbs(d3-d2)/Pip,1)+"/"+DoubleToString(OSMa_c,0),7,"Verdana",HistoricalLabelColor);
     }}
     int sig=0;
     if(AlertON){sig=1;}else{sig=0;}
     if(AlertON && (DoubleToStr(MathAbs(d2-d1)/Pip,1))>=DoubleToStr(AlertValue,1) && alerts1<1){alerts1=alerts1+1;Alert(Symbol()+" [ "+TF+" ] at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" ZigZag above "+DoubleToStr(AlertValue,1)+" at "+DoubleToStr(MathAbs(d2-d1)/Pip,1)+" value" );}
     if(SoundON && (DoubleToStr(MathAbs(d2-d1)/Pip,1))>=DoubleToStr(AlertValue,1) && alerts2<SoundNumber+sig){alerts2=alerts2+1;PlaySound(AlertSoundFile);}
     if((DoubleToStr(MathAbs(d2-d1)/Pip,1))<DoubleToStr(AlertValue,1)){alerts1=0;alerts2=0;}     
     
   return(0);
  }
  
  

//+------------------------------------------------------------------+
